/**
 * Sample React Native App
 * https://github.com/facebook/react-native
 *
 * @format
 * @flow strict-local
 */

import React, { useEffect } from 'react';
import {
  SafeAreaView,
  StyleSheet,
  ScrollView,
  View,
  Text,
  StatusBar,
  Alert,
} from 'react-native';

import {
  Header,
  LearnMoreLinks,
  Colors,
  DebugInstructions,
  ReloadInstructions,
} from 'react-native/Libraries/NewAppScreen';

import FontAwesome5 from 'react-native-vector-icons/FontAwesome5';
import FontAwesome from 'react-native-vector-icons/FontAwesome';
import Ionicons from 'react-native-vector-icons/Ionicons';
import firebase from '@react-native-firebase/app';
import OneSignal from 'react-native-onesignal';
import codePush from "react-native-code-push";

import Intro from "./src/screens/Tugas/Tugas1/Intro"
import Biodata from "./src/screens/Tugas/Tugas2/Biodata"
import TodoList from "./src/screens/Tugas/Tugas3/TodoList"
import Kontek from "./src/screens/Tugas/Tugas4"
import AppNavigation from "./src/navigation/routes"

FontAwesome.loadFont();
FontAwesome5.loadFont;
Ionicons.loadFont();


var firebaseConfig = {
  apiKey: "AIzaSyBTJEZS7j0Xhi6caQ0FzFuiUe_i1GUuLUs",
  authDomain: "sanbercode-7d6d7.firebaseapp.com",
  databaseURL: "https://sanbercode-7d6d7.firebaseio.com",
  projectId: "sanbercode-7d6d7",
  storageBucket: "sanbercode-7d6d7.appspot.com",
  messagingSenderId: "365936067783",
  appId: "1:365936067783:web:a2a1ee374b6eed9e3b6ae2",
  measurementId: "G-8ZSQX9C4SX"
};

if (!firebase.apps.length) {
  firebase.initializeApp(firebaseConfig)
}


// code-push release-react <appName> <platform>

// code-push release-react MyApp-iOS ios
// code-push release-react MyApp-Android android

// # Release a mandatory update with a changelog
// code-push release-react MyApp-iOS ios -m --description "Modified the header color"

// # Release an update for an app that uses a non-standard entry file name, and also capture
// # the sourcemap file generated by react-native bundle
// code-push release-react MyApp-iOS ios --entryFile MyApp.js --sourcemapOutput ../maps/MyApp.map

// # Release a dev Android build to just 1/4 of your end users
// code-push release-react MyApp-Android android --rollout 25% --dev true

// # Release an update that targets users running any 1.1.* binary, as opposed to
// # limiting the update to exact version name in the build.gradle file
// code-push release-react MyApp-Android android --targetBinaryVersion "~1.1.0"

// untuk liat histori update applikasi
// code-push deployment list <APP_NAME>

// untuk promote dari staging ke production 20% pengguna
// code-push promote <APP_NAME> Staging Production -r 20%

// memperluas production sampai 100%
// code-push patch <APP_NAME> Production -r 100%

const App: () => React$Node = () => {

  useEffect(() => {
    //Remove this method to stop OneSignal Debugging 
    OneSignal.setLogLevel(6, 0);

    // Replace 'YOUR_ONESIGNAL_APP_ID' with your OneSignal App ID.
    OneSignal.init("b5c43192-d586-46cc-a8d0-7e80d511cad7", { kOSSettingsKeyAutoPrompt: false, kOSSettingsKeyInAppLaunchURL: false, kOSSettingsKeyInFocusDisplayOption: 2 });
    OneSignal.inFocusDisplaying(2);   // Controls what should happen if a notification is received while the app is open. 2 means that the notification will go directly to the device's notification center.

    // The promptForPushNotifications function code will show the iOS push notification prompt. We recommend removing the following code and instead using an In-App Message to prompt for notification permission (See step below)
    //OneSignal.promptForPushNotificationsWithUserResponse(myiOSPromptCallback);

    OneSignal.addEventListener('received', onReceived);
    OneSignal.addEventListener('opened', onOpened);
    OneSignal.addEventListener('ids', onIds);


    codePush.sync({
      updateDialog: true,
      installMode: codePush.InstallMode.IMMEDIATE
    }, SyncStatus)

    return () => {
      OneSignal.removeEventListener('received', onReceived);
      OneSignal.removeEventListener('opened', onOpened);
      OneSignal.removeEventListener('ids', onIds);
    }
  }, []);

  const SyncStatus = (status) => {
    switch (status) {
      case codePush.SyncStatus.CHECKING_FOR_UPDATE:
        console.log("checking for update");
        break;
      case codePush.SyncStatus.DOWNLOADING_PACKAGE:
        console.log("downloading package");
        break;
      case codePush.SyncStatus.UP_TO_DATE:
        console.log("Up To Date");
        break;
      case codePush.SyncStatus.INSTALLING_UPDATE:
        console.log("Installing Upadte");
        break;
      case codePush.SyncStatus.UPDATE_INSTALLED:
        console.log("Update Installed");
        Alert.alert('Notification', 'Update Installed')
        break;
      case codePush.SyncStatus.AWAITING_USER_ACTION:
        console.log("Awaiting User Action");
        break;
      default:
        break;
    }
  }


  const onReceived = (notification) => {
    console.log("Notification received: ", notification);

  }

  const onOpened = (openResult) => {
    console.log('Message: ', openResult.notification.payload.body);
    console.log('Data: ', openResult.notification.payload.additionalData);
    console.log('isActive: ', openResult.notification.isAppInFocus);
    console.log('openResult: ', openResult);
  }

  const onIds = (device) => {
    console.log('Device info: ', device);
  }

  const myiOSPromptCallback = (permission) => {
    // do something with permission value
  }

  return (
    // <Intro />
    // <Biodata />
    // <TodoList/>
    // <Kontek />
    <AppNavigation />
  );

};

export default App;
